#ifndef WIN12_BL_H
#define WIN12_BL_H

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
#include <QObject>
#include <QTimer>
#include <QDebug>
#include <QScrollBar>
#include <QPlainTextEdit>
#include <QComboBox>
#include <QLabel>
#include <QScrollArea>
#include <QSerialPortInfo>
#include <QWidget>
#include <QListWidget>
#include <QGroupBox>
#include <QPushButton>
#include <QRadioButton>
#include "tslib.h"
#include "stepList.h"
#include "plugin.h"
#include "QPushButton"
#include "QTextEdit"
#include "QFileDialog"
#include "QStringList"
#include "guidefs.h"


class T_win12 : public QWidget
{
    Q_OBJECT

    //QGridLayout *myLayout;
    QHBoxLayout *myH0layer, *myH1layer;
    QVBoxLayout *myVmainlayer, *myVlayer_left;
    QVBoxLayout *myVlayer_midd;
    QVBoxLayout *myVlayer_right;

    hwinf *HWaccess;
    uint16_t myNextStep;
    uint8_t myStep;
    QLabel *lab1;
    QLabel *lab2;
    QLabel *lab3;
    QTimer *myTO;
    QLabel  *showState, *showFile;
    QPushButton *but1, *but2, *but3, *but4, *but5, *but6, *but7, *but8, *but9, *but10;
    bool trigger_BLstartup;
    int  retryCtr;
    QTextEdit *showProgress;

public:
    explicit T_win12(hwinf *HWaccess = nullptr, QWidget *parent = nullptr);
    bool work_ini(uint16_t *nextScreen, uint8_t *useNavi);
        // useNavi=0: no change
        // bit0,1: enable/disable button "next"
        // bit2,3: enable/disable button "home"
        // bit4,5: enable/disable button "back"
    bool working (uint16_t *nextScreen, uint8_t *useNavi);
    ~T_win12();

public slots:
    void Nav_back(void);
    void Nav_home(void);
    void Nav_next(void);

    void slot_b1(void);
    void slot_b2(void);
    void slot_b3(void);
    void slot_b4(void);
    void slot_b5(void);
    void slot_b6(void);
    void slot_b7(void);
    void slot_b8(void);
    void slot_b9(void);
    void slot_b10(void);

};

#endif
